#!/usr/bin/env python

"""
This test illustrates the need for usage to be propagated forward to the
assignment within the loop.
"""

class C:
    def e(self):    # unused
        return 1

    def f(self):
        return 1

class D:
    def f(self):
        return 2

    def g(self):
        return 3

class E:
    def e(self):
        return 4

    def f(self):
        return 0    # stops the test loop

    def g(self):
        return 5

def test_loop(obj, obj2):
    while obj.f():
        obj.g()
        obj = obj2  # should support e, f, g
        obj.e()
    return obj.f()

c = C()
d = D()
e = E()
result1_0 = test_loop(d, e)

# vim: tabstop=4 expandtab shiftwidth=4
